// Generated from com/celum/dbtool/sql/SqlGrammar.g4 by ANTLR 4.0
package com.celum.dbtool.sql;
import org.antlr.v4.runtime.atn.*;
import org.antlr.v4.runtime.dfa.DFA;
import org.antlr.v4.runtime.*;
import org.antlr.v4.runtime.misc.*;
import org.antlr.v4.runtime.tree.*;
import java.util.List;
import java.util.Iterator;
import java.util.ArrayList;

@SuppressWarnings({"all", "warnings", "unchecked", "unused", "cast"})
public class SqlGrammarParser extends Parser {
	protected static final DFA[] _decisionToDFA;
	protected static final PredictionContextCache _sharedContextCache =
		new PredictionContextCache();
	public static final int
		Expression=1, Begin=2, End=3, Terminator=4, HexLiteral=5, DecimalLiteral=6, 
		OctalLiteral=7, FloatingPointLiteral=8, CharacterLiteral=9, StringLiteral=10, 
		Identifier=11, WS=12, COMMENT=13, LINE_COMMENT=14, LINE_COMMENT_2=15;
	public static final String[] tokenNames = {
		"<INVALID>", "Expression", "'BEGIN'", "'END'", "';'", "HexLiteral", "DecimalLiteral", 
		"OctalLiteral", "FloatingPointLiteral", "CharacterLiteral", "StringLiteral", 
		"Identifier", "WS", "COMMENT", "LINE_COMMENT", "LINE_COMMENT_2"
	};
	public static final int
		RULE_sql = 0, RULE_sqlCommand = 1, RULE_beginScript = 2, RULE_endScript = 3;
	public static final String[] ruleNames = {
		"sql", "sqlCommand", "beginScript", "endScript"
	};

	@Override
	public String getGrammarFileName() { return "SqlGrammar.g4"; }

	@Override
	public String[] getTokenNames() { return tokenNames; }

	@Override
	public String[] getRuleNames() { return ruleNames; }

	@Override
	public ATN getATN() { return _ATN; }

	public SqlGrammarParser(TokenStream input) {
		super(input);
		_interp = new ParserATNSimulator(this,_ATN,_decisionToDFA,_sharedContextCache);
	}
	public static class SqlContext extends ParserRuleContext {
		public List<SqlCommandContext> sqlCommand() {
			return getRuleContexts(SqlCommandContext.class);
		}
		public List<EndScriptContext> endScript() {
			return getRuleContexts(EndScriptContext.class);
		}
		public BeginScriptContext beginScript(int i) {
			return getRuleContext(BeginScriptContext.class,i);
		}
		public EndScriptContext endScript(int i) {
			return getRuleContext(EndScriptContext.class,i);
		}
		public List<BeginScriptContext> beginScript() {
			return getRuleContexts(BeginScriptContext.class);
		}
		public SqlCommandContext sqlCommand(int i) {
			return getRuleContext(SqlCommandContext.class,i);
		}
		public SqlContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_sql; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof SqlGrammarListener ) ((SqlGrammarListener)listener).enterSql(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof SqlGrammarListener ) ((SqlGrammarListener)listener).exitSql(this);
		}
	}

	public final SqlContext sql() throws RecognitionException {
		SqlContext _localctx = new SqlContext(_ctx, getState());
		enterRule(_localctx, 0, RULE_sql);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(11); 
			_errHandler.sync(this);
			_la = _input.LA(1);
			do {
				{
				setState(11);
				switch (_input.LA(1)) {
				case Begin:
					{
					setState(8); beginScript();
					}
					break;
				case Expression:
				case DecimalLiteral:
				case CharacterLiteral:
				case StringLiteral:
				case Identifier:
					{
					setState(9); sqlCommand();
					}
					break;
				case End:
					{
					setState(10); endScript();
					}
					break;
				default:
					throw new NoViableAltException(this);
				}
				}
				setState(13); 
				_errHandler.sync(this);
				_la = _input.LA(1);
			} while ( (((_la) & ~0x3f) == 0 && ((1L << _la) & ((1L << Expression) | (1L << Begin) | (1L << End) | (1L << DecimalLiteral) | (1L << CharacterLiteral) | (1L << StringLiteral) | (1L << Identifier))) != 0) );
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class SqlCommandContext extends ParserRuleContext {
		public TerminalNode Expression(int i) {
			return getToken(SqlGrammarParser.Expression, i);
		}
		public List<TerminalNode> StringLiteral() { return getTokens(SqlGrammarParser.StringLiteral); }
		public TerminalNode Terminator() { return getToken(SqlGrammarParser.Terminator, 0); }
		public TerminalNode CharacterLiteral(int i) {
			return getToken(SqlGrammarParser.CharacterLiteral, i);
		}
		public TerminalNode DecimalLiteral(int i) {
			return getToken(SqlGrammarParser.DecimalLiteral, i);
		}
		public TerminalNode Identifier(int i) {
			return getToken(SqlGrammarParser.Identifier, i);
		}
		public List<TerminalNode> DecimalLiteral() { return getTokens(SqlGrammarParser.DecimalLiteral); }
		public List<TerminalNode> Expression() { return getTokens(SqlGrammarParser.Expression); }
		public List<TerminalNode> CharacterLiteral() { return getTokens(SqlGrammarParser.CharacterLiteral); }
		public List<TerminalNode> Identifier() { return getTokens(SqlGrammarParser.Identifier); }
		public TerminalNode StringLiteral(int i) {
			return getToken(SqlGrammarParser.StringLiteral, i);
		}
		public SqlCommandContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_sqlCommand; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof SqlGrammarListener ) ((SqlGrammarListener)listener).enterSqlCommand(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof SqlGrammarListener ) ((SqlGrammarListener)listener).exitSqlCommand(this);
		}
	}

	public final SqlCommandContext sqlCommand() throws RecognitionException {
		SqlCommandContext _localctx = new SqlCommandContext(_ctx, getState());
		enterRule(_localctx, 2, RULE_sqlCommand);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(16); 
			_errHandler.sync(this);
			_la = _input.LA(1);
			do {
				{
				{
				setState(15);
				_la = _input.LA(1);
				if ( !((((_la) & ~0x3f) == 0 && ((1L << _la) & ((1L << Expression) | (1L << DecimalLiteral) | (1L << CharacterLiteral) | (1L << StringLiteral) | (1L << Identifier))) != 0)) ) {
				_errHandler.recoverInline(this);
				}
				consume();
				}
				}
				setState(18); 
				_errHandler.sync(this);
				_la = _input.LA(1);
			} while ( (((_la) & ~0x3f) == 0 && ((1L << _la) & ((1L << Expression) | (1L << DecimalLiteral) | (1L << CharacterLiteral) | (1L << StringLiteral) | (1L << Identifier))) != 0) );
			setState(20); match(Terminator);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class BeginScriptContext extends ParserRuleContext {
		public TerminalNode Begin() { return getToken(SqlGrammarParser.Begin, 0); }
		public BeginScriptContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_beginScript; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof SqlGrammarListener ) ((SqlGrammarListener)listener).enterBeginScript(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof SqlGrammarListener ) ((SqlGrammarListener)listener).exitBeginScript(this);
		}
	}

	public final BeginScriptContext beginScript() throws RecognitionException {
		BeginScriptContext _localctx = new BeginScriptContext(_ctx, getState());
		enterRule(_localctx, 4, RULE_beginScript);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(22); match(Begin);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class EndScriptContext extends ParserRuleContext {
		public TerminalNode Terminator() { return getToken(SqlGrammarParser.Terminator, 0); }
		public TerminalNode End() { return getToken(SqlGrammarParser.End, 0); }
		public EndScriptContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_endScript; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof SqlGrammarListener ) ((SqlGrammarListener)listener).enterEndScript(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof SqlGrammarListener ) ((SqlGrammarListener)listener).exitEndScript(this);
		}
	}

	public final EndScriptContext endScript() throws RecognitionException {
		EndScriptContext _localctx = new EndScriptContext(_ctx, getState());
		enterRule(_localctx, 6, RULE_endScript);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(24); match(End);
			setState(25); match(Terminator);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static final String _serializedATN =
		"\2\3\21\36\4\2\t\2\4\3\t\3\4\4\t\4\4\5\t\5\3\2\3\2\3\2\6\2\16\n\2\r\2"+
		"\16\2\17\3\3\6\3\23\n\3\r\3\16\3\24\3\3\3\3\3\4\3\4\3\5\3\5\3\5\3\5\2"+
		"\6\2\4\6\b\2\3\5\3\3\b\b\13\r\35\2\r\3\2\2\2\4\22\3\2\2\2\6\30\3\2\2\2"+
		"\b\32\3\2\2\2\n\16\5\6\4\2\13\16\5\4\3\2\f\16\5\b\5\2\r\n\3\2\2\2\r\13"+
		"\3\2\2\2\r\f\3\2\2\2\16\17\3\2\2\2\17\r\3\2\2\2\17\20\3\2\2\2\20\3\3\2"+
		"\2\2\21\23\t\2\2\2\22\21\3\2\2\2\23\24\3\2\2\2\24\22\3\2\2\2\24\25\3\2"+
		"\2\2\25\26\3\2\2\2\26\27\7\6\2\2\27\5\3\2\2\2\30\31\7\4\2\2\31\7\3\2\2"+
		"\2\32\33\7\5\2\2\33\34\7\6\2\2\34\t\3\2\2\2\5\r\17\24";
	public static final ATN _ATN =
		ATNSimulator.deserialize(_serializedATN.toCharArray());
	static {
		_decisionToDFA = new DFA[_ATN.getNumberOfDecisions()];
	}
}